package org.ioc.commons.utils;

public class Format {
	public static String substitute(String text, Object... params) {
		return substitute(false, text, params);
	}

	public static String substitute(boolean nullAsEmptyString, String text, Object... params) {
		for (int i = 0; i < params.length; i++) {
			Object p = params[i];
			String value = (p != null || !nullAsEmptyString) ? String.valueOf(p) : null;
			text = text.replaceAll("\\{" + i + "}", safeRegexReplacement(value));
		}
		return text;
	}

	protected static String safeRegexReplacement(String replacement) {
		if (replacement == null) {
			return "";
		}

		return replacement.replaceAll("\\\\", "\\\\\\\\").replaceAll("\\$", "\\\\\\$");
	}

	public static String capitalize(String str) {
		int strLen;
		if (str == null || (strLen = str.length()) == 0) {
			return str;
		}
		return new StringBuffer(strLen).append(str.substring(0, 1).toUpperCase()).append(str.substring(1)).toString();
	}

	public static String decapitalize(String str) {
		int strLen;
		if (str == null || (strLen = str.length()) == 0) {
			return str;
		}
		return new StringBuffer(strLen).append(str.substring(0, 1).toLowerCase()).append(str.substring(1)).toString();
	}
}
